part of 'floative_factory.dart';

class _FloativeFactoryImpl implements FloativeFactory {
  static final _registeredInstances = <Type, Object>{};

  bool _isRegistered(T) => _registeredInstances.containsKey(T);

  bool _isNotRegistered(T, Object instance) => !(_isRegistered(T));

  @override
  T get<T>() {
    if (_isRegistered(T)) {
      var result = _registeredInstances[T];
      return result;
    } else {
      return null;
    }
  }

  @override
  void register<T>(Object instance, {bool overrideInstance = false}) {
    if (_isNotRegistered(T, instance)) {
      _registeredInstances.putIfAbsent(T, () => instance);
    } else {
      if (overrideInstance) {
        _registeredInstances[T] = instance;
      }
    }
  }

  @override
  void registerLazySingleton<T>(Object instance) {}

  @override
  void dispose<T>() {
    if (_isRegistered(T)) {
      _registeredInstances.remove(T);
    }
  }
}
