import 'dart:async';

import 'package:floative/ship/route_utils.dart';
import 'package:flutter/material.dart';

import "../core/exception/floative_exception.dart";

part 'ship_impl.dart';

abstract class Ship {
  GlobalKey<NavigatorState> navigationKey;

  List<Widget> pageStack;

  static Ship _instance;

  /// access to the Singleton instance of Ship
  static Ship get instance {
    _instance ??= _ShipImpl();
    return _instance;
  }

  /// Short form to access the instance of Ship
  static Ship get I => instance;

  factory Ship.newInstance() {
    return _ShipImpl();
  }

  void to({Widget page});

  void back({result});

  void replace({Widget page});

  void goBackTo({Widget page});

  Future<T> startPageForResult<T>({Widget page});

  Future<dynamic> showDialog(
      {Widget dialog,
      bool isDismissible = true,
      Color backGroundColor = Colors.transparent});

  Future<dynamic> showBottomSheet(
      {Widget bottomSheet,
      bool isDismissible = true,
      bool enableDrag = true,
      bool isScrollControlled = false,
      Color backGroundColor = Colors.transparent});

  void closeDialog({result});
}
